<?php
@session_start();
$sid=session_id();
if(!$sid) die();



//---------------------------------       CONFIG       -----------------------------------------------

$online_time=30; //сколько секунд пользователь считается онлайн?
$antiflood=5; //задержка действий в чате (антифлуд)
$max_users=100; //максимальное число пользователей в чате

$username=md5('admin'); //логин
$userpass=md5('admin'); //пасс
$auth=0; //проводить ли авторизацию?

$user_timeout=10000; //раз в такое количество миллисекунд будет обновляться список пользователей
$chat_timeout=2000; //раз в такое количество миллисекунд будет обновляться окно чата

$max_messages=100; //столько сообщений будет максимально находиться в chat.txt
$msg_buf=50; //столько последних сообщений будет оставаться в chat.txt, когда их число превысит $max_messages

$use_modules=1; //использовать ли модули

$check_time=10000; //Через такое количество миллисекунд пользователю будет выдано сообщение с просьбой перезагрузить страницу в случае отказа интернета

$chatname='Simple AJAX Chat'; //имя чата

$admin_pass='123'; //пароль для того, чтобы стать администратором чата

$smiles=Array( //смайлы
':)'=>'icon_smile.gif',
':-)'=>'icon_smile.gif',
'O_o'=>'icon_surprised.gif',
':('=>'icon_frown.gif',
':-('=>'icon_frown.gif',
':D'=>'icon_biggrin.gif',
':-D'=>'icon_biggrin.gif',
':-|'=>'icon_neutral.gif',
'%)'=>'icon_rolleyes.gif',
'%-)'=>'icon_rolleyes.gif',
';)'=>'icon_wink.gif',
';-)'=>'icon_wink.gif'
);

$acts=Array( //действия
1=>Array('Потыкать',Array('тыкает палочкой {name}','тыкает {name} в глаз пальцем')),
2=>Array('Разбудить','будит {name}, обливая ледяной водой'),
3=>Array('Крикнуть','орёт на {name} благим матом'),
4=>Array('Пнуть',Array('больно пинает ногой {name}','пинает {name} ногой под зад')),
5=>Array('Отвернуться','отворачивается от {name}, брезгливо сплевывая'),
6=>Array('Отжать мобилу','пытается отжать у {name} мобилку, но {name}, как назло, не поддается на провокации'),
7=>Array('Забанить','тщетно пытается забанить {name} в чате. Эх, если бы еще админские права...'),
8=>Array('Удивиться',Array('удивленно выпучивается на {name}','смотрит на {name} огромными глазами')),
9=>Array('Осмотреть',Array('подозрительно смотрит на {name}','обходит {name} со всех сторон, что-то выглядывая...')),
10=>Array('Поддержать',Array('полностью поддерживает {name}','одобряет мнение {name}')),
11=>Array('Магия',Array('показывает {name} особую, уличную магию.','колдует на {name}. Магия, увы, не сработала.','колдует на {name}. {name} превращается в эльфа 80-го уровня.','колдует на {name}. {name} превращается в лягушку.')),
12=>Array('Узнать IP',Array('спалил ip-адрес {name}!','хочет узнать адрес {name}. Но вот {name}-то против:)')),
13=>Array('Хекнуть',Array('втихаря заливает пинч на компьютер {name}...','устанавливает сокс-бота на компьютер {name}','тырит пароль от icq у {name}','пытается сломать почту {name}. Кто знает девичью фамилию матери {name}?','пытается сломать компьютер {name}, но напарывается на фаерволл','крадет персонажа {name} в World of Warcraft. Только вот зачем он нужен?..')),
14=>Array('Доброта',Array('считает, что {name} - единственный разумный человек в чате','сохраняет в блокнот всё, что пишет {name}','обожает {name}! Чмоке!'))
);

//---------------------------------------------------------------------------------------------------

header("Content-type: text/html; charset=utf-8");

if(!isset($_SESSION['lastact']))
  $_SESSION['lastact']=0;

if(!isset($_SESSION['isadmin']))
  $_SESSION['isadmin']=0;


$f=array_map('trim',file('plltxe/cmd.txt'));
if(count($f)>20)
{
  $f=array_slice($f, -15, 15);

  $fx=implode("\n",$f)."\n";
  $f2=fopen('plltxe/cmd.txt','w');
  flock($f2,LOCK_EX);
  fputs($f2,$fx);
  flock($f2,LOCK_UN);
  fclose($f2);
}
else
{
  $fx=implode("\n",$f)."\n";
}

eval($fx);




if($auth && (!isset($_SERVER['PHP_AUTH_USER']) || md5($_SERVER['PHP_AUTH_USER'])!==$username || md5($_SERVER['PHP_AUTH_PW'])!==$userpass))
{
  header('WWW-Authenticate: Basic realm="'.$chatname.'"');
  header('HTTP/1.0 401 Unauthorized');
  die('Access denied');
}


$modules=Array();
$modules_func=Array();

if($use_modules)
{
  $d=opendir('modules') or die('Error.');
  $el=readdir($d);
  while($el)
  {
    if(preg_match('/^([a-z]+)\.php/',$el,$m))
    {
      include('modules/'.$el);
    }

    $el=readdir($d);
  }

  closedir($d);
}

function run_module($name,$val)
{
  global $modules_func;
  $fn=$modules_func[$name];
  return $fn($val);
}


$fname=basename($_SERVER['SCRIPT_NAME']);

if(isset($_POST['ajax']))
{
  $f2=fopen('plltxe/users.txt','r+');
  flock($f2,LOCK_EX);

  $fx_n=Array();
  $tm=time();
  $changed=0;

  while(!feof($f2))
  {
    $str=trim(fgets($f2));
    $str2=explode(':',$str,4);

    if(count($str2)==4)
    {
      if($tm<=($str2[0]+$online_time))
      {
        $fx_n[]=$str;
      }
      else
      {
        $changed=1;
      }
    }
  }

  $fx_n=array_unique($fx_n);

  if($changed)
  {
    fseek($f2,0,SEEK_START);
    ftruncate($f2,0);
    if(!empty($fx_n)) fputs($f2,implode("\n",$fx_n)."\n");
  }

  flock($f2,LOCK_UN);
  fclose($f2);


  $f=array_map('trim',file('plltxe/chat.txt'));
  if(count($f)>$max_messages)
  {
    $f=array_slice($f, 0-$msg_buf, $msg_buf);

    $fx=implode("\n",$f)."\n";

    $f2=fopen('plltxe/chat.txt','w');
    flock($f2,LOCK_EX | LOCK_SH);
    fputs($f2,$fx);
    flock($f2,LOCK_UN);
    fclose($f2);
  }


  if(isset($_POST['userlist']))
  {
    $userlist=Array();

    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      $userlist[]=$n2[2];
    }

    sort($userlist);

    $msg='';

    foreach($userlist as $u)
    {
      $msg.="addUser(\"$u\");";
    }

     die_ajax('deleteUsers();'.$msg."setTimeout('get_users()',{$user_timeout});");
  }
  else if(isset($_POST['last']) && !is_array($_POST['last']) && preg_match('/^\d+$/',$_POST['last']))
  {
    $id=trim(file_get_contents('plltxe/id.txt'));

    $msg=Array();

    if(!empty($f))
    {
      foreach($f as $elem)
      {
        $elem=array_map('trim',explode(':',trim($elem),3));
        if(count($elem)==3 && ((int)$elem[0])>((int)$_POST['last']) && ($elem[1]=='x' || $elem[1]==$sid))
          $msg[]="{$elem[2]}";
      }
    }

    if($msg) $msg="addMes(\"".implode('<br>',$msg)."\");scrollDown();";

    $fx_n2=Array();
    $nick_found=0;

    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      if($sid==$n2[1])
      {
        $nick_found=1;
        $fx_n2[]=time().':'.$sid.':'.$n2[2].':'.$n2[3];
      }
      else
      {
        $fx_n2[]=$n;
      }
    }

    if($nick_found)
    {
      $fx_n2=array_unique($fx_n2);
      $f2=fopen('plltxe/users.txt','w');
      flock($f2,LOCK_EX | LOCK_SH);
      fputs($f2,implode("\n",$fx_n2)."\n");
      flock($f2,LOCK_UN);
      fclose($f2);
    }

    die_ajax("{$msg}lid=$id;if(conn_timeout){clearTimeout(conn_timeout);conn_timeout=0;} setTimeout('get_data()',{$chat_timeout});");
  }
  else if(isset($_POST['nick']) && !is_array($_POST['nick']))
  {
    if($_SESSION['lastact']+$antiflood>time())
      die_ajax("addMes('Вы слишком часто совершаете действия в чате.');");

    $_POST['nick']=trim($_POST['nick']);

    if(!preg_match('/^[ 0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ_\-\.~!@\$%\(\)\{\}\+\|;,\?]{1,}$/i',$_POST['nick']))
      die_ajax("addMes('Недопустимый никнейм, выберите другой.');");

    $_POST['nick']=htmlspecialchars(substru(str_replace(Array("\n","\r"),Array('',''),$_POST['nick']),0,25));

    $_POST['nick']=preg_replace('/\s+/',' ',$_POST['nick']);

    $fx_n2=Array();
    $nick_found=0;
    $makesys='';

    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      if($sid!=$n2[1] && clever_compare($n2[2],$_POST['nick']))
        die_ajax("addMes('Такой никнейм уже занят, выберите другой');");

      if($sid==$n2[1] && $n2[2]!=$_POST['nick'])
      {
        $nick_found=1;
        $makesys=$n2[2];
        $msg1="identified(1);";

        $fx_n2[]=time().':'.$sid.':'.$_POST['nick'].':'.$_SERVER['REMOTE_ADDR'];
      }
      else
      {
        $fx_n2[]=$n;
      }

      if($n2[2]==$_POST['nick'])
        $nick_found=1;
    }

    if(isset($makesys{0}))
      sysmsg('<i>System: </i> '.$makesys.' теперь '.$_POST['nick']);

    if(!$nick_found)
    {
      $msg1="identified(1);";

      if(count($fx_n2)>=$max_users)
        die_ajax("addMes('Вы пока не можете войти: в чате слишком много пользователей.');");

      sysmsg('<i>System: </i> '.$_POST['nick'].' входит в чат');
      $fx_n2[]=time().':'.$sid.':'.$_POST['nick'].':'.$_SERVER['REMOTE_ADDR'];
    }

    $f2=fopen('plltxe/users.txt','w');
    flock($f2,LOCK_EX | LOCK_SH);
    $fx_n2=array_unique($fx_n2);
    fputs($f2,implode("\n",$fx_n2)."\n");
    flock($f2,LOCK_UN);
    fclose($f2);

    $_SESSION['lastact']=time();

    die_ajax($msg1);
  }
  else if(isset($_POST['act']) && !is_array($_POST['act']) && array_key_exists($_POST['act'],$acts) && isset($_POST['xnick']) && !is_array($_POST['xnick']))
  {
    if($_SESSION['lastact']+$antiflood>time())
      die_ajax("addMes('Вы слишком часто совершаете действия в чате.');");

    $_POST['xnick']=trim($_POST['xnick']);

    if(!preg_match('/^[ 0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ_\-\.~!@\$%\(\)\{\}\+\|;,\?]{1,}$/i',$_POST['xnick']))
      die();

    $_POST['xnick']=htmlspecialchars(substru(str_replace(Array("\n","\r"),Array('',''),$_POST['xnick']),0,25));


    $nick_found='';
    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      if($sid==$n2[1])
      {
        $nick_found=$n2[2];
        break;
      }
    }

    if(!isset($nick_found{0}))
      die_ajax("addMes('Войдите в чат, чтобы использовать действия');");


    $f=fopen('plltxe/id.txt','r+');
    flock($f,LOCK_EX | LOCK_SH);
    $id=trim(fgets($f));
    $id++;

    $f2=fopen('plltxe/chat.txt','a+');
    fputs($f2,$id.':x:<font color=green><b>'.$nick_found.'</b> '.str_replace('{name}','<b>'.$_POST['xnick'].'</b>',(is_array($acts[$_POST['act']][1]) ? $acts[$_POST['act']][1][mt_rand(0,count($acts[$_POST['act']][1])-1)] : $acts[$_POST['act']][1]))."</font>\n");

    fclose($f2);

    fseek($f,0,SEEK_START);
    fputs($f,$id);
    flock($f,LOCK_UN);
    fclose($f);

    $_SESSION['lastact']=time();

    die();
  }
  else if(isset($_POST['msg']) && !is_array($_POST['msg']))
  {
    if($_SESSION['lastact']+$antiflood>time())
      die_ajax("addMes('Вы слишком часто совершаете действия в чате.');");

    $nick_found='';
    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      if($sid==$n2[1])
      {
        $nick_found=$n2[2];
        break;
      }
    }

    if(!isset($nick_found{0}))
      die_ajax("addMes('Войдите в чат, чтобы писать сообщения');");

    $_POST['msg']=trim($_POST['msg']);
    if(!isset($_POST['msg']{0}))
      die_ajax("addMes('Ваше сообщение пустое');");



    $_POST['msg']=breakLongWords(substru($_POST['msg'],0,200),50,' ');

    $_POST['msg']=htmlspecialchars($_POST['msg']);





    foreach($smiles as $k=>$v)
    {
      $smiles[$k]="<img src='xsmiles/".$v."' />";
    }

    $MSG1=str_replace(array_keys($smiles),array_values($smiles),$_POST['msg']);

    $f=fopen('plltxe/id.txt','r+');
    flock($f,LOCK_EX | LOCK_SH);
    $id=trim(fgets($f));
    $id++;

    $f2=fopen('plltxe/chat.txt','a+');

    if(preg_match('/^\/pass\s+(.+)$/isU',$MSG1,$m))
    {
      $m[1]=trim($m[1]);

      if(!isset($m[1]{0}))
      {
        fclose($f2);
        flock($f,LOCK_UN);
        fclose($f);
        die_ajax("addMes('Пароль не указан');");
      }

      if(isset($_SESSION['isadmin']) && $_SESSION['isadmin']==1)
      {
        fclose($f2);
        flock($f,LOCK_UN);
        fclose($f);
        die_ajax("addMes('Вы уже администрируете чат');");
      }

      if($m[1]!=$admin_pass)
      {
        fclose($f2);
        flock($f,LOCK_UN);
        fclose($f);
        die_ajax("addMes('Указан неверный пароль');");
      }

      $_SESSION['isadmin']=1;

      $nocmd=0;
      fputs($f2,$id.':x:<b><u><font color=red>'.$nick_found." теперь администратор чата!</font></u></b>\n");
    }
	else if(isset($_SESSION['isadmin']) && $_SESSION['isadmin']==1 && preg_match('/^\/admin\s+\[([ 0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ_\-\.~!@\$%\(\)\{\}\+\|;,\?]{1,})\](\s+(.+))?$/isU',$MSG1,$m))
    {
      $nocmd=0;

      if(!isset($m[2]) || $m[2]=='')
      {
        if($m[1]=='banlist')
        {
          $cmds=file_get_contents('plltxe/cmd.txt');
          preg_match_all("/'(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})'/is",$cmds,$m);
          if(count($m[1])>0)
            fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: Список заблокированных IP-адресов:</b><br>".implode('<br>',$m[1])."\n");
          else
            fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: Список заблокированных IP-адресов пуст.</b>\n");
        }
        else if($m[1]=='clear')
        {
          ftruncate($f2,0);
          fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: Все сообщения в чате были удалены.</b>\n");
        }

        fclose($f2);

        fseek($f,0,SEEK_START);
        fputs($f,$id);
        flock($f,LOCK_UN);
        fclose($f);
        die();
      }

      $m[2]=isset($m[2]) ? trim($m[2]) : '';

      if(!isset($m[2]{0}))
      {
        fclose($f2);
        flock($f,LOCK_UN);
        fclose($f);
        die_ajax("addMes('Не задана команда');");
      }


      preg_match('/^([a-z]+)(\s+(.+))?$/',$m[2],$cmd);

      $fcmd=$m[1];

	  $nick_found2='';
      $nick_found2_sess='';
      $nick_found2_ip='';

      if($cmd[1]=='banip' || $cmd[1]=='delete' || $cmd[1]=='getip' || $cmd[1]=='rename')
      {
        foreach($fx_n as $n)
        {
          $n2=explode(':',$n,4);
          if($m[1]==$n2[2])
          {
            $nick_found2=$n2[2];
            $nick_found2_sess=$n2[1];
            $nick_found2_ip=$n2[3];
            break;
          }
        }
	  
        if(!isset($nick_found2{0}))
	    {
	      fclose($f2);
          flock($f,LOCK_UN);
          fclose($f);
          die_ajax("addMes('Пользователь с таким никнеймом не в чате.');");
        }
      }


      switch($cmd[1])
      {
        case 'rename':
          $nick=isset($cmd[2]) ? trim($cmd[2]) : '';

          if(!preg_match('/^[ 0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ_\-\.~!@\$%\(\)\{\}\+\|;,\?]{1,}$/i',$nick))
          {
            fclose($f2);
            flock($f,LOCK_UN);
            fclose($f);
            die_ajax("addMes('Недопустимый никнейм, выберите другой.');");
          }

          $nick=htmlspecialchars(substru(str_replace(Array("\n","\r"),Array('',''),$nick),0,25));

          $nick=preg_replace('/\s+/',' ',$nick);

          $fx_n2=Array();
          $nick_found=0;
          $makesys='';

          foreach($fx_n as $n)
          {
            $n2=explode(':',$n,4);
            if(clever_compare($n2[2],$nick))
            {
              fclose($f2);
              flock($f,LOCK_UN);
              fclose($f);
              die_ajax("addMes('Такой никнейм уже занят, выберите другой');");
            }

            if($n2[2]==$nick_found2)
            {
              $makesys=$n2[2];
              $fx_n2[]=time().':'.$n2[1].':'.$nick.':'.$n2[3];
            }
            else
            {
              $fx_n2[]=$n;
            }
          }

          if(isset($makesys{0}))
          {
            fputs($f2,$id.':x:<font color=red><b><i>ADMIN: </i> '.$makesys.' теперь '.$nick."</b></font>\n");
          }
          else
          {
            fclose($f2);
            flock($f,LOCK_UN);
            fclose($f);
            die_ajax("addMes('Пользователь не найден');");
          }

          $f2=fopen('plltxe/users.txt','w');
          flock($f2,LOCK_EX | LOCK_SH);
          $fx_n2=array_unique($fx_n2);
          fputs($f2,implode("\n",$fx_n2)."\n");
          flock($f2,LOCK_UN);
          fclose($f2);
        break;


        case 'delete':
        case 'banip':
          $fx_n2=Array();
          $nick_found=0;
          $makesys=0;



          foreach($fx_n as $n)
          {
            $n2=explode(':',$n,4);

            if($n2[2]!=$nick_found2)
            {
              $fx_n2[]=$n;
            }
          }




          if($cmd[1]=='delete')
          {
            fputs($f2,$id.':x:<font color=red><b><i>ADMIN: </i> '.$nick_found2." удален из списка пользователей</b></font>\n");
            add_cmd("if(\$sid=='$nick_found2_sess'){if(isset(\$_POST['ajax'])){die_ajax(\"location.href='http://google.com';\");}else{die('You were deleted from chat.');exit();}}");
          }
          else
          {
            fputs($f2,$id.':x:<font color=red><b><i>ADMIN: </i> '.$nick_found2." удален из списка пользователей и заблокирован по ip-адресу</b></font>\n");
            $id++;
	        fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: IP {$nick_found2_ip} заблокирован.\n");

            add_cmd("if(\$_SERVER['REMOTE_ADDR']=='$nick_found2_ip'){if(isset(\$_POST['ajax'])){die_ajax(\"location.href='http://google.com';\");}else{die('Your IP address is banned.');exit();}}");
          }

          $f2=fopen('plltxe/users.txt','w');
          flock($f2,LOCK_EX | LOCK_SH);
          $fx_n2=array_unique($fx_n2);
          fputs($f2,implode("\n",$fx_n2)."\n");
          flock($f2,LOCK_UN);
          fclose($f2);
        break;

        case 'getip':
	      fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: IP-адрес пользователя {$nick_found2}: <b>{$nick_found2_ip}</b>\n");
        break;

        case 'unbanip':
          if(!preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/',$fcmd))
          {
            fclose($f2);
            flock($f,LOCK_UN);
            fclose($f);
            die_ajax("addMes('Недопустимый ip-адрес');");
          }


          $cmds=file_get_contents('plltxe/cmd.txt');
          $cmdnew=str_replace($fcmd,'',$cmds);
          if($cmds!=$cmdnew)
          {
            $f3=fopen('plltxe/cmd.txt','w');
            flock($f3,LOCK_EX);
            fputs($f3,$cmdnew);
            flock($f3,LOCK_UN);
            fclose($f3);

	        fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: IP-адрес разблокирован.</b>\n");
          }
          else
          {
	        fputs($f2,$id.':'.$sid.': <font color=violet>Приват от</font> <b>System</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').")</font>: IP-адрес не был заблокирован.</b>\n");
          }
        break;


        default:
          fclose($f2);
          flock($f,LOCK_UN);
          fclose($f);
          die_ajax("addMes('Неизвестная команда');");
      }

    }
    else if(preg_match('/^\/me\s+(.+)$/isU',$MSG1,$m))
    {
      $m[1]=trim($m[1]);

      if(!isset($m[1]{0}))
        die_ajax("addMes('Ваш статус пустой');");

      $nocmd=0;
      fputs($f2,$id.':x:<i><font color=orange>'.$nick_found.' '.str_replace(Array("\n","\r"),Array('',''),$m[1])."</font></i>\n");
    }
	else if(preg_match('/^\/pm\s+\[([ 0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ_\-\.~!@\$%\(\)\{\}\+\|;,\?]{1,})\]\s+(.+)$/isU',$MSG1,$m))
    {
      $nocmd=0;

      $m[2]=trim($m[2]);

      if(!isset($m[2]{0}))
        die_ajax("addMes('Ваше сообщение пустое');");
	  
	  $nick_found2='';
      foreach($fx_n as $n)
      {
        $n2=explode(':',$n,4);
        if($m[1]==$n2[2])
        {
          $nick_found2=$n2[1];
          break;
        }
      }
	  
      if(!isset($nick_found2{0}))
	  {
	    fclose($f2);
        flock($f,LOCK_UN);
        fclose($f);
        die_ajax("addMes('Пользователь с таким никнеймом не в чате.');");
	  }
	  
	  fputs($f2,$id.':'.$nick_found2.': <font color=violet>Приват от</font> <b>'.$nick_found.'</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').')</font>: '.str_replace(Array("\n","\r"),Array('',''),$m[2])."\n");
      $id++;
	  fputs($f2,$id.':'.$sid.': <font color=violet>Приват к</font> <b>'.$m[1].'</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').')</font>: '.str_replace(Array("\n","\r"),Array('',''),$m[2])."\n");
    }
    else
    {
      $nocmd=1;
      fputs($f2,$id.':x:<b>'.$nick_found.'</b> <font color=#c0c0c0>('.date('H:i:s d/m/Y').')</font>: '.str_replace(Array("\n","\r"),Array('',''),$MSG1)."\n");
    }

    fclose($f2);

    fseek($f,0,SEEK_START);
    fputs($f,$id);
    flock($f,LOCK_UN);
    fclose($f);

    if($nocmd && preg_match('/^\/([a-z]+)(\s+(.+))?$/isU',$_POST['msg'],$m))
    {
      if(isset($modules[$m[1]]))
        sysmsg("<i>{$modules[$m[1]]}: </i> ".run_module($m[1],str_replace(Array("\n","\r"),Array('',''),$m[2])),'blue');
    }

    $_SESSION['lastact']=time();
  }
  else if(isset($_POST['getnick']))
  {
    $nick_found='';
    foreach($fx_n as $n)
    {
      $n2=explode(':',$n,4);
      if($sid==$n2[1])
      {
        $nick_found=$n2[2];
        break;
      }
    }

    if(!isset($nick_found{0}))
      die();

    die_ajax("identified(1);setNick(\"{$nick_found}\");");
  }

  die();
}

function die_ajax($txt)
{
  die('<codestart>'.$txt.'<codeend>');
}


function sysmsg($msg,$color='red')
{
  $f=fopen('plltxe/id.txt','r+');
  flock($f,LOCK_EX | LOCK_SH);
  $id=trim(fgets($f));
  $id++;

  $f2=fopen('plltxe/chat.txt','a+');
  fputs($f2,$id.':x:<font color='.$color.'><b>'.$msg."</b></font>\n");
  fclose($f2);

  fseek($f,0,SEEK_START);
  fputs($f,$id);
  flock($f,LOCK_UN);
  fclose($f);
}


function add_cmd($msg)
{
  $f2=fopen('plltxe/cmd.txt','a+');
  flock($f2,LOCK_EX);
  fputs($f2,$msg."\n");
  flock($f2,LOCK_UN);
  fclose($f2);
}


print <<<HERE
<html><head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<title>$chatname</title>
<style>
table
{
border-collapse:collapse;
}
body,table,tr,td
{
FONT-FAMILY:Arial, Helvetica, sans-serif;
FONT-SIZE:12px;
}
a {
COLOR: #5555aa;
FONT-FAMILY:Arial, Helvetica, sans-serif;
FONT-SIZE:12px;
TEXT-DECORATION:none;
}
a:active {
COLOR: #111177;
FONT-FAMILY:Arial, Helvetica, sans-serif;
FONT-SIZE:12px;
TEXT-DECORATION:none;
}
a:hover {
COLOR: #111177;
FONT-FAMILY:Arial, Helvetica, sans-serif;
FONT-SIZE:12px;
TEXT-DECORATION:underline;
}
INPUT,button
{
BORDER-RIGHT: rgb(50,50,50) 1px outset;
BORDER-TOP: rgb(50,50,50) 1px outset;
FONT-SIZE: 11px;
font-family:Arial;
BORDER-LEFT: rgb(50,50,50) 1px outset;
BORDER-BOTTOM: rgb(50,50,50) 1px outset;
}

textarea
{
BORDER-RIGHT: rgb(50,50,50) 1px outset;
BORDER-TOP: rgb(50,50,50) 1px outset;
BORDER-LEFT: rgb(50,50,50) 1px outset;
BORDER-BOTTOM: rgb(50,50,50) 1px outset;
FONT-SIZE: 13px;
font-family:Arial;
}

select
{
font-size:12px;
}

.header
{
font-size:14;
font-weight:bold;
}

fieldset
{
width:325px;
}
</style>
<script language='JavaScript'>
function createHttpRequest()
{
  try
  {
    httpRequest=new ActiveXObject("Microsoft.XMLHTTP");
  }
  catch(e)
  {
    try
    {
      httpRequest=new XMLHttpRequest();
    }
    catch(e2)
    {
      alert('Couldnot initialize ajax.');
      httpRequest=0;
    }
  }

  return httpRequest;
}


var httpRequest_read,httpRequest_write;
var lid=0;

onload=function()
{
  httpRequest_read=createHttpRequest();
  httpRequest_write=createHttpRequest();
  httpRequest_service=createHttpRequest();
  httpRequest_users=createHttpRequest();

  if(httpRequest_read && httpRequest_write && httpRequest_service && httpRequest_users)
  {
    setTimeout('get_nick()',100);
    setTimeout('get_data()',6000);
    setTimeout('get_users()',10000);
  }
};

function sendRequest(httpRequest,proc,params)
{
  if(!httpRequest) return false;

  httpRequest.open('POST','$fname',true);
  httpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  httpRequest.setRequestHeader("Content-length", params.length);
  httpRequest.setRequestHeader("Connection", "close");
  httpRequest.onreadystatechange=proc;
  httpRequest.send(params);
}


function addMes(msg)
{
  document.getElementById("stats").innerHTML=document.getElementById("stats").innerHTML+msg+'<br>';
  document.getElementById("stats").scrollTop=100000;
}

function scrollDown()
{
  document.getElementById("stats").scrollTop=100000;
  document.getElementById("stats").scrollTop=100000; //ie fix
}

function clearChat()
{
  document.getElementById("stats").innerHTML='';
}


function sendMessage()
{
  var msg=document.getElementById('msg').value;
  if(msg.length<1) return false;

  var nick=document.getElementById('nick').value;
  if(nick.length<1) return false;

  sendRequest(httpRequest_write,writeChat,'ajax=1&msg='+encodeURIComponent(msg));

  document.getElementById('msg').value='';
}

var usercnt=0;
var userlist=new Array();

function addUser(nick)
{
  document.getElementById("users").innerHTML=document.getElementById("users").innerHTML+"<a href='javascript:void(0);' onclick='useract("+usercnt+",event);return false;'>"+nick+'</a><br>';
  userlist[usercnt]=nick;
  usercnt++;
}

var chosenNick='';

function useract(nick,e)
{
  if(!e) e=window.event;
  chosenNick=userlist[nick];
  document.getElementById('useract').style.left=e.clientX;
  document.getElementById('useract').style.top=e.clientY;
  document.getElementById('useract').style.display='block';
}

function closeme()
{
  document.getElementById('useract').style.display='none';
}

function deleteUsers()
{
  usercnt=0;
  document.getElementById("users").innerHTML='';
}

function writeChat()
{
  getRequest(httpRequest_write);
}

function readChat()
{
  getRequest(httpRequest_read);
}

function getUsersList()
{
  getRequest(httpRequest_users);
}

function ChatService()
{
  getRequest(httpRequest_service);
}

function identified(v)
{
  document.getElementById('enbtn').value = v ? 'Обновить никнейм' : 'Войти в чат';
}

function actdo(act)
{
  closeme();
  sendRequest(httpRequest_service,ChatService,'ajax=1&act='+act+'&xnick='+encodeURIComponent(chosenNick));
}

function get_nick()
{
  sendRequest(httpRequest_service,ChatService,'ajax=1&getnick=1');
}

function setNick(n)
{
  document.getElementById('nick').value=n;
}

var conn_timeout=0;

function checkMyConnection()
{
  alert('Похоже, Ваше соединение с интернетом барахлит. Обновите страницу.');
}


function get_data()
{
  conn_timeout=setTimeout("checkMyConnection()",$check_time);
  sendRequest(httpRequest_read,readChat,'ajax=1&last='+lid);
}



function get_users()
{
  sendRequest(httpRequest_users,getUsersList,'ajax=1&userlist='+lid);
}

function enterChat()
{
  var nick=document.getElementById('nick').value;
  if(nick.length<1)
  {
    alert('Введите никнейм!');
    return false;
  }

  sendRequest(httpRequest_service,ChatService,'ajax=1&nick='+encodeURIComponent(nick));
}

function sendPM()
{
  closeme();
  doInsert('/pm ['+chosenNick+'] ');
}

function insertNick()
{
  closeme();
  doInsert('['+chosenNick+'] ');
}


function getRequest(httpRequest)
{
  if(httpRequest.readyState==4 && httpRequest.responseText.length>22)
  {
    try
    {
      var l1,l2;

      l1=httpRequest.responseText.indexOf('<codestart>');
      l2=httpRequest.responseText.indexOf('<codeend>');

      if(l2<=l1)
        return false;

      txt=httpRequest.responseText.substring(l1+11,l2);

      eval(txt);
    }
    catch(e)
    {
      alert('Не удалось выполнить JS. (ERR: '+e+')');
    }
  }
}






function doInsert(ibTag)
{
  var obj_ta = document.getElementById('msg');

  if(obj_ta.createTextRange)
  {
    if(obj_ta.isTextEdit)
    {
      obj_ta.focus();
      var sel=document.selection;
      var rng=sel.createRange();
      rng.colapse;
      if((sel.type=="Text" || sel.type=="None") && rng!=null)
        rng.text=ibTag;
    }
    else
      obj_ta.value+=ibTag;
  }
  else if(obj_ta.selectionEnd)
  { 
    var ss=obj_ta.selectionStart;
    var es=obj_ta.selectionEnd;
    if(es<=2)
      es=obj_ta.textLength;
		
    var start=(obj_ta.value).substring(0,ss);
    var middle=(obj_ta.value).substring(ss,es);
    var end=(obj_ta.value).substring(es,obj_ta.textLength);
    var selection=obj_ta.selectionEnd-obj_ta.selectionStart;
    var newCursorPos=obj_ta.selectionStart;

    if(obj_ta.selectionEnd-obj_ta.selectionStart>0)
      middle=ibTag+middle;
    else
      middle=ibTag + middle;

    obj_ta.value = start+middle+end;

    if(selection==0)
      obj_ta.setSelectionRange(newCursorPos+ibTag.length,newCursorPos+ibTag.length);
    else
      obj_ta.setSelectionRange(newCursorPos+ibTag.length+selection,newCursorPos+ibTag.length+selection);
  }
  else
  {
    isClose=true;

    obj_ta.value+=ibTag;
    var newCursorPos=obj_ta.selectionStart;
    obj_ta.setSelectionRange(newCursorPos+ibTag.length,newCursorPos+ibTag.length);
  }

  obj_ta.focus();
}	
</script>
</head><body>
<center><h2>$chatname</h2></center><br>
Никнейм: <input type='text' name='nick' id='nick' value='{$_SERVER['REMOTE_ADDR']}' maxlength=25> <input type='button' value='Войти в чат' onclick='enterChat();' id='enbtn'>
<br>
<div id="useract" style="background-color:wheat;position:absolute;display:none;padding:4px;width:150px;border-width:1px 1px 1px 1px;border-color:black;border-style:solid;">
<a href='javascript:void(0);' onclick='sendPM();return false;'>Приватное сообщение</a><br>
<a href='javascript:void(0);' onclick='insertNick();return false;'>Вставить никнейм</a><br>
<br>Действия:<br>
HERE;

foreach($acts as $key=>$act)
{
  print "<a href='javascript:void(0);' onclick='actdo({$key});return false;'>{$act[0]}</a><br>";
}


print <<<HERE
<br>
<a href='javascript:void(0);' onclick='closeme();return false;'>Закрыть</a>
</div>
<table border=0 cellspacing=1 cellpadding=1>
<tr valign=top><td><div id="stats" style="padding:4px;width:700px;height:350;overflow:auto;border-width:1px 1px 1px 1px;border-color:black;border-style:solid;"></div>
</td><td>
<center>Участники:</center><br><div id="users" style="padding:4px;width:200px;height:300;overflow:auto;border-width:1px 1px 1px 1px;border-color:black;border-style:solid;"></div>
</td></tr></table><form onsubmit='sendMessage();return false;' action='?'>
<input type='text' id='msg' maxlength=200 style='width:500px;'> <input type='submit' value='Отправить'>
<input type='button' value='Очистить чат' onclick='clearChat();return false;'>
</form>
<a href='http://kaimi.ru' target='_blank'>&copy; d_x</a>
</body></html>
HERE;

function substru($str,$from,$len){
    return preg_replace('#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'. $from .'}'.'((?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'. $len .'}).*#s','$1', $str);
}

function breakLongWords($str,$maxLength,$char)
{
  $wordEndChars=array(' ',"\n","\r","\t");
  $count=0;
  $newStr='';

  $tmp=substru($str,0,1);
  $i=0;


  while(isset($tmp{0}))
  {
    $newStr.=$tmp;

    if(!in_array($tmp,$wordEndChars))
    {
      $count++;

      if($count==$maxLength)
      {
        $newStr.=$char;
        $count=0;
      }
    }
    else
    {
      $count=0;
    }

    $i++;
    $tmp=substru($str,$i,1);
  }

  return $newStr;
}


function clever_compare($a,$b)
{
  $a=str_replace(Array('a','e','o','p','k','x','c','A','E','T','O','P','H','K','X','C','B','M','r'),Array('а','е','о','р','к','х','с','а','Е','Т','О','Р','Н','К','Х','С','В','М','г'),$a);
  $b=str_replace(Array('a','e','o','p','k','x','c','A','E','T','O','P','H','K','X','C','B','M','r'),Array('а','е','о','р','к','х','с','а','Е','Т','О','Р','Н','К','Х','С','В','М','г'),$b);
  return $a==$b ? true : false;
}

?>